diff --git a/app/Exceptions/Handler.php b/app/Exceptions/Handler.php
index 67e5bc4..becf49e 100644
--- a/app/Exceptions/Handler.php
+++ b/app/Exceptions/Handler.php
@@ -6,7 +6,7 @@ use Exception;
 use Illuminate\Auth\Access\AuthorizationException;
 use Illuminate\Auth\AuthenticationException;
 use Illuminate\Database\Eloquent\ModelNotFoundException;
-use Illuminate\Http\Exception\HttpResponseException;
+use Illuminate\Http\Exceptions\HttpResponseException;
 use Illuminate\Session\TokenMismatchException;
 use Illuminate\Validation\ValidationException;
 use Symfony\Component\HttpKernel\Exception\HttpException;
diff --git a/app/Http/Controllers/ActivityController.php b/app/Http/Controllers/ActivityController.php
index 66affea..291935b 100644
--- a/app/Http/Controllers/ActivityController.php
+++ b/app/Http/Controllers/ActivityController.php
@@ -24,6 +24,7 @@ class ActivityController extends Controller
      */
     public function __construct(ActivityRepository $activities)
     {
+        $this->middleware('auth');
         $this->middleware('permission:users.activity');
         $this->activities = $activities;
     }
diff --git a/app/Http/Controllers/Auth/SocialAuthController.php b/app/Http/Controllers/Auth/SocialAuthController.php
index ffe75e0..a71a898 100644
--- a/app/Http/Controllers/Auth/SocialAuthController.php
+++ b/app/Http/Controllers/Auth/SocialAuthController.php
@@ -188,7 +188,7 @@ class SocialAuthController extends Controller
      */
     private function handleMissingEmail($socialUser)
     {
-        Session::set('social.user', $socialUser);
+        Session::put('social.user', $socialUser);
 
         return redirect()->to('auth/twitter/email');
     }
@@ -201,6 +201,11 @@ class SocialAuthController extends Controller
      */
     private function loginAndRedirect($user)
     {
+        if ($user->isBanned()) {
+            return redirect()->to('login')
+                ->withErrors(trans('app.your_account_is_banned'));
+        }
+
         if (settings('2fa.enabled') && Authy::isEnabled($user)) {
             session()->put('auth.2fa.id', $user->id);
             return redirect()->route('auth.token');
diff --git a/app/Http/Controllers/InstallController.php b/app/Http/Controllers/InstallController.php
index 6205e9d..7e57338 100644
--- a/app/Http/Controllers/InstallController.php
+++ b/app/Http/Controllers/InstallController.php
@@ -70,7 +70,7 @@ class InstallController extends Controller
                 ->withErrors("Connection to your database cannot be established. Please provide correct database credentials.");
         }
 
-        Session::set('install.db_credentials', $dbCredentials);
+        Session::put('install.db_credentials', $dbCredentials);
 
         return view('install.installation');
     }
diff --git a/app/Http/Controllers/PermissionsController.php b/app/Http/Controllers/PermissionsController.php
index 1863fa3..f4c12de 100644
--- a/app/Http/Controllers/PermissionsController.php
+++ b/app/Http/Controllers/PermissionsController.php
@@ -33,6 +33,7 @@ class PermissionsController extends Controller
      */
     public function __construct(RoleRepository $roles, PermissionRepository $permissions)
     {
+        $this->middleware('auth');
         $this->middleware('permission:permissions.manage');
         $this->roles = $roles;
         $this->permissions = $permissions;
diff --git a/app/Http/Controllers/ProfileController.php b/app/Http/Controllers/ProfileController.php
index cd9d20c..b40b6b4 100644
--- a/app/Http/Controllers/ProfileController.php
+++ b/app/Http/Controllers/ProfileController.php
@@ -100,9 +100,16 @@ class ProfileController extends Controller
      */
     public function updateAvatar(Request $request, UserAvatarManager $avatarManager)
     {
-        $name = $avatarManager->uploadAndCropAvatar($this->theUser);
+        $this->validate($request, [
+            'avatar' => 'image'
+        ]);
 
-        return $this->handleAvatarUpdate($name);
+        if ($name = $avatarManager->uploadAndCropAvatar($this->theUser)) {
+            return $this->handleAvatarUpdate($name);
+        }
+
+        return redirect()->route('profile')
+            ->withErrors(trans('app.avatar_not_changed'));
     }
 
     /**
diff --git a/app/Http/Controllers/RolesController.php b/app/Http/Controllers/RolesController.php
index 1ecfd4c..2d5309e 100644
--- a/app/Http/Controllers/RolesController.php
+++ b/app/Http/Controllers/RolesController.php
@@ -31,6 +31,7 @@ class RolesController extends Controller
      */
     public function __construct(RoleRepository $roles)
     {
+        $this->middleware('auth');
         $this->middleware('permission:roles.manage');
         $this->roles = $roles;
     }
diff --git a/app/Http/Controllers/SettingsController.php b/app/Http/Controllers/SettingsController.php
index 77352ea..25fca49 100644
--- a/app/Http/Controllers/SettingsController.php
+++ b/app/Http/Controllers/SettingsController.php
@@ -12,6 +12,11 @@ use Settings;
  */
 class SettingsController extends Controller
 {
+    public function __construct()
+    {
+        $this->middleware('auth');
+    }
+
     /**
      * Display general settings page.
      *
diff --git a/app/Http/Controllers/UsersController.php b/app/Http/Controllers/UsersController.php
index caae686..90847b9 100644
--- a/app/Http/Controllers/UsersController.php
+++ b/app/Http/Controllers/UsersController.php
@@ -197,16 +197,21 @@ class UsersController extends Controller
      * @param UserAvatarManager $avatarManager
      * @return mixed
      */
-    public function updateAvatar(User $user, UserAvatarManager $avatarManager)
+    public function updateAvatar(User $user, UserAvatarManager $avatarManager, Request $request)
     {
-        $name = $avatarManager->uploadAndCropAvatar($user);
+        $this->validate($request, ['avatar' => 'image']);
 
-        $this->users->update($user->id, ['avatar' => $name]);
+        if ($name = $avatarManager->uploadAndCropAvatar($user)) {
+            $this->users->update($user->id, ['avatar' => $name]);
 
-        event(new UpdatedByAdmin($user));
+            event(new UpdatedByAdmin($user));
+
+            return redirect()->route('user.edit', $user->id)
+                ->withSuccess(trans('app.avatar_changed'));
+        }
 
         return redirect()->route('user.edit', $user->id)
-            ->withSuccess(trans('app.avatar_changed'));
+            ->withErrors(trans('app.avatar_not_changed'));
     }
 
     /**
diff --git a/app/Http/Middleware/SocialLogin.php b/app/Http/Middleware/SocialLogin.php
index 2089644..ec9be61 100644
--- a/app/Http/Middleware/SocialLogin.php
+++ b/app/Http/Middleware/SocialLogin.php
@@ -16,7 +16,7 @@ class SocialLogin
      */
     public function handle($request, Closure $next)
     {
-        $provider = $request->route()->getParameter('provider');
+        $provider = $request->route()->parameter('provider');
 
         if (! in_array($provider, config('auth.social.providers'))) {
             throw new NotFoundHttpException;
diff --git a/app/Listeners/RoleEventsSubscriber.php b/app/Listeners/RoleEventsSubscriber.php
index 730ac6c..fdcf618 100644
--- a/app/Listeners/RoleEventsSubscriber.php
+++ b/app/Listeners/RoleEventsSubscriber.php
@@ -2,18 +2,16 @@
 
 namespace Portal\Listeners;
 
-use Portal\Activity;
 use Portal\Events\Role\Created;
 use Portal\Events\Role\PermissionsUpdated;
 use Portal\Events\Role\Updated;
 use Portal\Events\Role\Deleted;
-use Portal\Events\User\UserEventContract;
 use Portal\Services\Logging\UserActivity\Logger;
 
 class RoleEventsSubscriber
 {
     /**
-     * @var UserActivityLogger
+     * @var Logger
      */
     private $logger;
 
diff --git a/app/Providers/HtmlServiceProvider.php b/app/Providers/HtmlServiceProvider.php
index 6f9a049..eafadbc 100644
--- a/app/Providers/HtmlServiceProvider.php
+++ b/app/Providers/HtmlServiceProvider.php
@@ -25,10 +25,10 @@ class HtmlServiceProvider extends BaseHtmlServiceProvider
         $this->app->singleton('form', function($app) {
 
             if (env('FORCE_SSL')) {
-                $app['url']->forceSchema('https');
+                $app['url']->forceScheme('https');
             }
 
-            $form = new FormBuilder($app['html'], $app['url'], $app['view'], $app['session.store']->getToken());
+            $form = new FormBuilder($app['html'], $app['url'], $app['view'], $app['session.store']->token());
 
             return $form->setSessionStore($app['session.store']);
         });
diff --git a/app/Repositories/Session/DbSession.php b/app/Repositories/Session/DbSession.php
index be1a74d..c5d93cd 100644
--- a/app/Repositories/Session/DbSession.php
+++ b/app/Repositories/Session/DbSession.php
@@ -2,6 +2,7 @@
 
 namespace Portal\Repositories\Session;
 
+use Carbon\Carbon;
 use Portal\Repositories\User\UserRepository;
 use DB;
 
@@ -26,8 +27,11 @@ class DbSession implements SessionRepository
      */
     public function getUserSessions($userId)
     {
+        $validTimestamp = Carbon::now()->subMinutes(config('session.lifetime'))->timestamp;
+
         return DB::table('sessions')
             ->where('user_id', $userId)
+            ->where('last_activity', '>=', $validTimestamp)
             ->get(['id', 'ip_address', 'user_agent', 'last_activity'])
             ->all();
     }
diff --git a/app/Repositories/User/EloquentUser.php b/app/Repositories/User/EloquentUser.php
index 405f89b..bb0ba23 100644
--- a/app/Repositories/User/EloquentUser.php
+++ b/app/Repositories/User/EloquentUser.php
@@ -117,7 +117,7 @@ class EloquentUser implements UserRepository
      */
     public function update($id, array $data)
     {
-        if (array_get($data, 'country_id') == 0) {
+        if (! array_get($data, 'country_id')) {
             $data['country_id'] = null;
         }
 
diff --git a/app/Services/Auth/TwoFactor/Authenticatable.php b/app/Services/Auth/TwoFactor/Authenticatable.php
index d5d55af..8254942 100644
--- a/app/Services/Auth/TwoFactor/Authenticatable.php
+++ b/app/Services/Auth/TwoFactor/Authenticatable.php
@@ -2,12 +2,8 @@
 
 namespace Portal\Services\Auth\TwoFactor;
 
-use Illuminate\Auth\Authenticatable as BaseAuthenticatable;
-
 trait Authenticatable
 {
-    use BaseAuthenticatable;
-
     /**
      * Get the e-mail address used for two-factor authentication.
      *
diff --git a/app/Services/Upload/UserAvatarManager.php b/app/Services/Upload/UserAvatarManager.php
index 5b8c3d0..f4be86a 100644
--- a/app/Services/Upload/UserAvatarManager.php
+++ b/app/Services/Upload/UserAvatarManager.php
@@ -49,7 +49,14 @@ class UserAvatarManager
     {
         list($name, $avatarImage) = $this->uploadFile($user);
 
-        $this->cropAndResizeImage($avatarImage);
+        try {
+            $this->cropAndResizeImage($avatarImage);
+            $this->deleteAvatarIfUploaded($user);
+        } catch (\Exception $e) {
+            logger("Cannot upload avatar. " . $e->getMessage());
+            $this->fs->delete($this->getDestinationDirectory() . "/" . $name);
+            return null;
+        }
 
         return $name;
     }
@@ -86,8 +93,6 @@ class UserAvatarManager
      */
     private function uploadFile(User $user)
     {
-        $this->deleteAvatarIfUploaded($user);
-
         $name = $this->generateAvatarName();
         $uploadedFile = $this->getUploadedFileFromRequest();
 
diff --git a/app/User.php b/app/User.php
index 119b963..9182065 100644
--- a/app/User.php
+++ b/app/User.php
@@ -2,7 +2,6 @@
 
 namespace Portal;
 
-use Illuminate\Notifications\Messages\MailMessage;
 use Illuminate\Notifications\Notifiable;
 use Portal\Presenters\UserPresenter;
 use Portal\Services\Auth\TwoFactor\Authenticatable as TwoFactorAuthenticatable;
diff --git a/config/app.php b/config/app.php
index 9371dc8..3fc7d2f 100644
--- a/config/app.php
+++ b/config/app.php
@@ -23,7 +23,7 @@ return [
     | Portal Version
     |--------------------------------------------------------------------------
     */
-    'version' => '1.2.0',
+    'version' => '1.3.0',
 
     /*
     |--------------------------------------------------------------------------
diff --git a/config/database.php b/config/database.php
index b4e0677..7922d30 100644
--- a/config/database.php
+++ b/config/database.php
@@ -4,19 +4,6 @@ return [
 
     /*
     |--------------------------------------------------------------------------
-    | PDO Fetch Style
-    |--------------------------------------------------------------------------
-    |
-    | By default, database results will be returned as instances of the PHP
-    | stdClass object; however, you may desire to retrieve records in an
-    | array format for simplicity. Here you can tweak the fetch style.
-    |
-    */
-
-    'fetch' => PDO::FETCH_CLASS,
-
-    /*
-    |--------------------------------------------------------------------------
     | Default Database Connection Name
     |--------------------------------------------------------------------------
     |
@@ -123,6 +110,8 @@ return [
 
     'redis' => [
 
+        'client' => 'predis',
+
         'cluster' => false,
 
         'default' => [
diff --git a/config/mail.php b/config/mail.php
index 8f8fdd4..1741262 100644
--- a/config/mail.php
+++ b/config/mail.php
@@ -121,4 +121,21 @@ return [
 
     'pretend' => false,
 
+    /*
+    |--------------------------------------------------------------------------
+    | Markdown Mail Settings
+    |--------------------------------------------------------------------------
+    |
+    | If you are using Markdown based email rendering, you may configure your
+    | theme and component paths here, allowing you to customize the design
+    | of the emails. Or, you may simply stick with the Laravel defaults!
+    |
+    */
+    'markdown' => [
+        'theme' => 'default',
+        'paths' => [
+            resource_path('views/vendor/mail'),
+        ],
+    ],
+
 ];
diff --git a/database/factories/ModelFactory.php b/database/factories/ModelFactory.php
index 3cf545c..4498b48 100644
--- a/database/factories/ModelFactory.php
+++ b/database/factories/ModelFactory.php
@@ -39,7 +39,7 @@ $factory->define(Portal\Role::class, function (Faker\Generator $faker) {
     return [
         'name' => str_random(5),
         'display_name' => implode(" ", $faker->words(2)),
-        'description' => $faker->paragraph,
+        'description' => substr($faker->paragraph, 0, 255),
         'removable' => true,
     ];
 });
@@ -61,7 +61,7 @@ $factory->define(Activity::class, function (Faker\Generator $faker, array $attrs
 
     return [
         'user_id' => $userId,
-        'description' => $faker->paragraph,
+        'description' => substr($faker->paragraph, 0, 255),
         'ip_address' => $faker->ipv4,
         'user_agent' => $faker->userAgent
     ];
diff --git a/resources/lang/en/app.php b/resources/lang/en/app.php
index 4bee34e..4127a63 100644
--- a/resources/lang/en/app.php
+++ b/resources/lang/en/app.php
@@ -335,5 +335,7 @@ return [
         'October' => 'October',
         'November' => 'November',
         'December' => 'December',
-    ]
+    ],
+
+    'avatar_not_changed' => 'Avatar image cannot be updated. Please try again.',
 ];
diff --git a/resources/lang/sr/app.php b/resources/lang/sr/app.php
index 482cacb..98a0cd8 100644
--- a/resources/lang/sr/app.php
+++ b/resources/lang/sr/app.php
@@ -324,5 +324,7 @@ return [
         'October' => 'Oktobar',
         'November' => 'Novembar',
         'December' => 'Decembar',
-    ]
+    ],
+
+    'avatar_not_changed' => 'Avatar ne može biti ažuriran. Molimo pokušajte ponovo.',
 ];
diff --git a/resources/views/user/profile.blade.php b/resources/views/user/profile.blade.php
index 6b3f428..9a1fdb5 100644
--- a/resources/views/user/profile.blade.php
+++ b/resources/views/user/profile.blade.php
@@ -71,7 +71,7 @@
     <div role="tabpanel" class="tab-pane" id="auth">
         <div class="row">
             <div class="col-md-8">
-                {!! Form::open(['route' => 'profile.update.login-details', 'method' => 'PUT', 'id' => 'socials-form']) !!}
+                {!! Form::open(['route' => 'profile.update.login-details', 'method' => 'PUT', 'id' => 'login-details-form']) !!}
                     @include('user.partials.auth')
                 {!! Form::close() !!}
             </div>
@@ -106,7 +106,7 @@
     {!! JsValidator::formRequest('Portal\Http\Requests\User\UpdateDetailsRequest', '#details-form') !!}
     {!! JsValidator::formRequest('Portal\Http\Requests\User\UpdateProfileLoginDetailsRequest', '#login-details-form') !!}
 
-    @if (config('auth.2fa.enabled'))
+    @if (settings('2fa.enabled'))
         {!! JsValidator::formRequest('Portal\Http\Requests\User\EnableTwoFactorRequest', '#two-factor-form') !!}
     @endif
 @stop
\ No newline at end of file
diff --git a/routes/web.php b/routes/web.php
index 22203c5..49513eb 100644
--- a/routes/web.php
+++ b/routes/web.php
@@ -59,274 +59,279 @@ Route::get('auth/{provider}/callback', 'Auth\SocialAuthController@handleProvider
 Route::get('auth/twitter/email', 'Auth\SocialAuthController@getTwitterEmail');
 Route::post('auth/twitter/email', 'Auth\SocialAuthController@postTwitterEmail');
 
-/**
- * Other
- */
+Route::group(['middleware' => 'auth'], function () {
 
-Route::get('/', [
-    'as' => 'dashboard',
-    'uses' => 'DashboardController@index'
-]);
+    /**
+     * Dashboard
+     */
 
-/**
- * User Profile
- */
+    Route::get('/', [
+        'as' => 'dashboard',
+        'uses' => 'DashboardController@index'
+    ]);
 
-Route::get('profile', [
-    'as' => 'profile',
-    'uses' => 'ProfileController@index'
-]);
+    /**
+     * User Profile
+     */
 
-Route::get('profile/activity', [
-    'as' => 'profile.activity',
-    'uses' => 'ProfileController@activity'
-]);
+    Route::get('profile', [
+        'as' => 'profile',
+        'uses' => 'ProfileController@index'
+    ]);
 
-Route::put('profile/details/update', [
-    'as' => 'profile.update.details',
-    'uses' => 'ProfileController@updateDetails'
-]);
+    Route::get('profile/activity', [
+        'as' => 'profile.activity',
+        'uses' => 'ProfileController@activity'
+    ]);
 
-Route::post('profile/avatar/update', [
-    'as' => 'profile.update.avatar',
-    'uses' => 'ProfileController@updateAvatar'
-]);
+    Route::put('profile/details/update', [
+        'as' => 'profile.update.details',
+        'uses' => 'ProfileController@updateDetails'
+    ]);
 
-Route::post('profile/avatar/update/external', [
-    'as' => 'profile.update.avatar-external',
-    'uses' => 'ProfileController@updateAvatarExternal'
-]);
+    Route::post('profile/avatar/update', [
+        'as' => 'profile.update.avatar',
+        'uses' => 'ProfileController@updateAvatar'
+    ]);
 
-Route::put('profile/login-details/update', [
-    'as' => 'profile.update.login-details',
-    'uses' => 'ProfileController@updateLoginDetails'
-]);
+    Route::post('profile/avatar/update/external', [
+        'as' => 'profile.update.avatar-external',
+        'uses' => 'ProfileController@updateAvatarExternal'
+    ]);
 
-Route::put('profile/social-networks/update', [
-    'as' => 'profile.update.social-networks',
-    'uses' => 'ProfileController@updateSocialNetworks'
-]);
+    Route::put('profile/login-details/update', [
+        'as' => 'profile.update.login-details',
+        'uses' => 'ProfileController@updateLoginDetails'
+    ]);
 
-Route::post('profile/two-factor/enable', [
-    'as' => 'profile.two-factor.enable',
-    'uses' => 'ProfileController@enableTwoFactorAuth'
-]);
+    Route::put('profile/social-networks/update', [
+        'as' => 'profile.update.social-networks',
+        'uses' => 'ProfileController@updateSocialNetworks'
+    ]);
 
-Route::post('profile/two-factor/disable', [
-    'as' => 'profile.two-factor.disable',
-    'uses' => 'ProfileController@disableTwoFactorAuth'
-]);
+    Route::post('profile/two-factor/enable', [
+        'as' => 'profile.two-factor.enable',
+        'uses' => 'ProfileController@enableTwoFactorAuth'
+    ]);
 
-Route::get('profile/sessions', [
-    'as' => 'profile.sessions',
-    'uses' => 'ProfileController@sessions'
-]);
+    Route::post('profile/two-factor/disable', [
+        'as' => 'profile.two-factor.disable',
+        'uses' => 'ProfileController@disableTwoFactorAuth'
+    ]);
 
-Route::delete('profile/sessions/{session}/invalidate', [
-    'as' => 'profile.sessions.invalidate',
-    'uses' => 'ProfileController@invalidateSession'
-]);
+    Route::get('profile/sessions', [
+        'as' => 'profile.sessions',
+        'uses' => 'ProfileController@sessions'
+    ]);
 
-/**
- * User Management
- */
-Route::get('user', [
-    'as' => 'user.list',
-    'uses' => 'UsersController@index'
-]);
+    Route::delete('profile/sessions/{session}/invalidate', [
+        'as' => 'profile.sessions.invalidate',
+        'uses' => 'ProfileController@invalidateSession'
+    ]);
 
-Route::get('user/create', [
-    'as' => 'user.create',
-    'uses' => 'UsersController@create'
-]);
+    /**
+     * User Management
+     */
+    Route::get('user', [
+        'as' => 'user.list',
+        'uses' => 'UsersController@index'
+    ]);
 
-Route::post('user/create', [
-    'as' => 'user.store',
-    'uses' => 'UsersController@store'
-]);
+    Route::get('user/create', [
+        'as' => 'user.create',
+        'uses' => 'UsersController@create'
+    ]);
 
-Route::get('user/{user}/show', [
-    'as' => 'user.show',
-    'uses' => 'UsersController@view'
-]);
+    Route::post('user/create', [
+        'as' => 'user.store',
+        'uses' => 'UsersController@store'
+    ]);
 
-Route::get('user/{user}/edit', [
-    'as' => 'user.edit',
-    'uses' => 'UsersController@edit'
-]);
+    Route::get('user/{user}/show', [
+        'as' => 'user.show',
+        'uses' => 'UsersController@view'
+    ]);
 
-Route::put('user/{user}/update/details', [
-    'as' => 'user.update.details',
-    'uses' => 'UsersController@updateDetails'
-]);
+    Route::get('user/{user}/edit', [
+        'as' => 'user.edit',
+        'uses' => 'UsersController@edit'
+    ]);
 
-Route::put('user/{user}/update/login-details', [
-    'as' => 'user.update.login-details',
-    'uses' => 'UsersController@updateLoginDetails'
-]);
+    Route::put('user/{user}/update/details', [
+        'as' => 'user.update.details',
+        'uses' => 'UsersController@updateDetails'
+    ]);
 
-Route::delete('user/{user}/delete', [
-    'as' => 'user.delete',
-    'uses' => 'UsersController@delete'
-]);
+    Route::put('user/{user}/update/login-details', [
+        'as' => 'user.update.login-details',
+        'uses' => 'UsersController@updateLoginDetails'
+    ]);
 
-Route::post('user/{user}/update/avatar', [
-    'as' => 'user.update.avatar',
-    'uses' => 'UsersController@updateAvatar'
-]);
+    Route::delete('user/{user}/delete', [
+        'as' => 'user.delete',
+        'uses' => 'UsersController@delete'
+    ]);
 
-Route::post('user/{user}/update/avatar/external', [
-    'as' => 'user.update.avatar.external',
-    'uses' => 'UsersController@updateAvatarExternal'
-]);
+    Route::post('user/{user}/update/avatar', [
+        'as' => 'user.update.avatar',
+        'uses' => 'UsersController@updateAvatar'
+    ]);
 
-Route::post('user/{user}/update/social-networks', [
-    'as' => 'user.update.socials',
-    'uses' => 'UsersController@updateSocialNetworks'
-]);
+    Route::post('user/{user}/update/avatar/external', [
+        'as' => 'user.update.avatar.external',
+        'uses' => 'UsersController@updateAvatarExternal'
+    ]);
 
-Route::get('user/{user}/sessions', [
-    'as' => 'user.sessions',
-    'uses' => 'UsersController@sessions'
-]);
+    Route::post('user/{user}/update/social-networks', [
+        'as' => 'user.update.socials',
+        'uses' => 'UsersController@updateSocialNetworks'
+    ]);
 
-Route::delete('user/{user}/sessions/{session}/invalidate', [
-    'as' => 'user.sessions.invalidate',
-    'uses' => 'UsersController@invalidateSession'
-]);
+    Route::get('user/{user}/sessions', [
+        'as' => 'user.sessions',
+        'uses' => 'UsersController@sessions'
+    ]);
 
-Route::post('user/{user}/two-factor/enable', [
-    'as' => 'user.two-factor.enable',
-    'uses' => 'UsersController@enableTwoFactorAuth'
-]);
+    Route::delete('user/{user}/sessions/{session}/invalidate', [
+        'as' => 'user.sessions.invalidate',
+        'uses' => 'UsersController@invalidateSession'
+    ]);
 
-Route::post('user/{user}/two-factor/disable', [
-    'as' => 'user.two-factor.disable',
-    'uses' => 'UsersController@disableTwoFactorAuth'
-]);
+    Route::post('user/{user}/two-factor/enable', [
+        'as' => 'user.two-factor.enable',
+        'uses' => 'UsersController@enableTwoFactorAuth'
+    ]);
 
-/**
- * Roles & Permissions
- */
+    Route::post('user/{user}/two-factor/disable', [
+        'as' => 'user.two-factor.disable',
+        'uses' => 'UsersController@disableTwoFactorAuth'
+    ]);
 
-Route::get('role', [
-    'as' => 'role.index',
-    'uses' => 'RolesController@index'
-]);
+    /**
+     * Roles & Permissions
+     */
 
-Route::get('role/create', [
-    'as' => 'role.create',
-    'uses' => 'RolesController@create'
-]);
+    Route::get('role', [
+        'as' => 'role.index',
+        'uses' => 'RolesController@index'
+    ]);
 
-Route::post('role/store', [
-    'as' => 'role.store',
-    'uses' => 'RolesController@store'
-]);
+    Route::get('role/create', [
+        'as' => 'role.create',
+        'uses' => 'RolesController@create'
+    ]);
 
-Route::get('role/{role}/edit', [
-    'as' => 'role.edit',
-    'uses' => 'RolesController@edit'
-]);
+    Route::post('role/store', [
+        'as' => 'role.store',
+        'uses' => 'RolesController@store'
+    ]);
 
-Route::put('role/{role}/update', [
-    'as' => 'role.update',
-    'uses' => 'RolesController@update'
-]);
+    Route::get('role/{role}/edit', [
+        'as' => 'role.edit',
+        'uses' => 'RolesController@edit'
+    ]);
 
-Route::delete('role/{role}/delete', [
-    'as' => 'role.delete',
-    'uses' => 'RolesController@delete'
-]);
+    Route::put('role/{role}/update', [
+        'as' => 'role.update',
+        'uses' => 'RolesController@update'
+    ]);
 
+    Route::delete('role/{role}/delete', [
+        'as' => 'role.delete',
+        'uses' => 'RolesController@delete'
+    ]);
 
-Route::post('permission/save', [
-    'as' => 'permission.save',
-    'uses' => 'PermissionsController@saveRolePermissions'
-]);
 
-Route::resource('permission', 'PermissionsController');
+    Route::post('permission/save', [
+        'as' => 'permission.save',
+        'uses' => 'PermissionsController@saveRolePermissions'
+    ]);
 
-/**
- * Settings
- */
+    Route::resource('permission', 'PermissionsController');
 
-Route::get('settings', [
-    'as' => 'settings.general',
-    'uses' => 'SettingsController@general',
-    'middleware' => 'permission:settings.general'
-]);
+    /**
+     * Settings
+     */
 
-Route::post('settings/general', [
-    'as' => 'settings.general.update',
-    'uses' => 'SettingsController@update',
-    'middleware' => 'permission:settings.general'
-]);
+    Route::get('settings', [
+        'as' => 'settings.general',
+        'uses' => 'SettingsController@general',
+        'middleware' => 'permission:settings.general'
+    ]);
 
-Route::get('settings/auth', [
-    'as' => 'settings.auth',
-    'uses' => 'SettingsController@auth',
-    'middleware' => 'permission:settings.auth'
-]);
+    Route::post('settings/general', [
+        'as' => 'settings.general.update',
+        'uses' => 'SettingsController@update',
+        'middleware' => 'permission:settings.general'
+    ]);
 
-Route::post('settings/auth', [
-    'as' => 'settings.auth.update',
-    'uses' => 'SettingsController@update',
-    'middleware' => 'permission:settings.auth'
-]);
+    Route::get('settings/auth', [
+        'as' => 'settings.auth',
+        'uses' => 'SettingsController@auth',
+        'middleware' => 'permission:settings.auth'
+    ]);
+
+    Route::post('settings/auth', [
+        'as' => 'settings.auth.update',
+        'uses' => 'SettingsController@update',
+        'middleware' => 'permission:settings.auth'
+    ]);
 
 // Only allow managing 2FA if AUTHY_KEY is defined inside .env file
-if (env('AUTHY_KEY')) {
-    Route::post('settings/auth/2fa/enable', [
-        'as' => 'settings.auth.2fa.enable',
-        'uses' => 'SettingsController@enableTwoFactor',
+    if (env('AUTHY_KEY')) {
+        Route::post('settings/auth/2fa/enable', [
+            'as' => 'settings.auth.2fa.enable',
+            'uses' => 'SettingsController@enableTwoFactor',
+            'middleware' => 'permission:settings.auth'
+        ]);
+
+        Route::post('settings/auth/2fa/disable', [
+            'as' => 'settings.auth.2fa.disable',
+            'uses' => 'SettingsController@disableTwoFactor',
+            'middleware' => 'permission:settings.auth'
+        ]);
+    }
+
+    Route::post('settings/auth/registration/captcha/enable', [
+        'as' => 'settings.registration.captcha.enable',
+        'uses' => 'SettingsController@enableCaptcha',
         'middleware' => 'permission:settings.auth'
     ]);
 
-    Route::post('settings/auth/2fa/disable', [
-        'as' => 'settings.auth.2fa.disable',
-        'uses' => 'SettingsController@disableTwoFactor',
+    Route::post('settings/auth/registration/captcha/disable', [
+        'as' => 'settings.registration.captcha.disable',
+        'uses' => 'SettingsController@disableCaptcha',
         'middleware' => 'permission:settings.auth'
     ]);
-}
 
-Route::post('settings/auth/registration/captcha/enable', [
-    'as' => 'settings.registration.captcha.enable',
-    'uses' => 'SettingsController@enableCaptcha',
-    'middleware' => 'permission:settings.auth'
-]);
+    Route::get('settings/notifications', [
+        'as' => 'settings.notifications',
+        'uses' => 'SettingsController@notifications',
+        'middleware' => 'permission:settings.notifications'
+    ]);
 
-Route::post('settings/auth/registration/captcha/disable', [
-    'as' => 'settings.registration.captcha.disable',
-    'uses' => 'SettingsController@disableCaptcha',
-    'middleware' => 'permission:settings.auth'
-]);
+    Route::post('settings/notifications', [
+        'as' => 'settings.notifications.update',
+        'uses' => 'SettingsController@update',
+        'middleware' => 'permission:settings.notifications'
+    ]);
 
-Route::get('settings/notifications', [
-    'as' => 'settings.notifications',
-    'uses' => 'SettingsController@notifications',
-    'middleware' => 'permission:settings.notifications'
-]);
+    /**
+     * Activity Log
+     */
 
-Route::post('settings/notifications', [
-    'as' => 'settings.notifications.update',
-    'uses' => 'SettingsController@update',
-    'middleware' => 'permission:settings.notifications'
-]);
+    Route::get('activity', [
+        'as' => 'activity.index',
+        'uses' => 'ActivityController@index'
+    ]);
 
-/**
- * Activity Log
- */
+    Route::get('activity/user/{user}/log', [
+        'as' => 'activity.user',
+        'uses' => 'ActivityController@userActivity'
+    ]);
 
-Route::get('activity', [
-    'as' => 'activity.index',
-    'uses' => 'ActivityController@index'
-]);
+});
 
-Route::get('activity/user/{user}/log', [
-    'as' => 'activity.user',
-    'uses' => 'ActivityController@userActivity'
-]);
 
 /**
  * Installation
